Subject: Re: bug#34080: 27.0.50, 26.1; undocumented key bindings for *vc-diff*

From: Sean Whitton <[email-masked]>
Date: Sat, 19 Jul 2025 11:18:53 +0100

Hello,

On Sat 19 Jul 2025 at 09:57am +01, Sean Whitton wrote:

> Hello,
>
> On Fri 18 Jul 2025 at 09:24am -04, Stefan Monnier wrote:
>
>>> I spent some time seeing how this change would be implemented and I now
>>> think that, instead, diff-minor-mode should be renamed
>>> diff-read-only-mode.  Am I right that diff-minor-mode is only intended
>>> as a way to add bindings when diff-mode buffers are read-only?
>>
>> No, `diff-minor-mode` is intended for use in buffers that need to use
>> another major mode than `diff-mode`.
>> [ Like the difference between `outline-mode` and `outline-minor-mode`.  ]
>>
>> Not sure how important it is in practice: IIRC, I implemented this
>> because it existed in other people's "diff modes" (when I started
>> diff-mode I tried to make it a superset of all the diff/patch modes
>> I could find), rather than because I saw a need for it.
>
> Okay, thanks.
>
> Renaming it wouldn't prevent it being used in this way and would improve
> comprehensibility for 90% of users, so I'll go ahead with that.
>
> I'll also experimentally mark diff-minor-mode-prefix as obsolete.

No, that's not right, diff-minor-mode isn't used at all in read-only
diff-mode buffers.  The short bindings are activated in those in another
way.

As can be seen by my messages to this bug, all this has really confused
me, and I think it would confuse the next person, too.  I've tried to
add a clarificatory comment.  Also, I've fixed the original reported
issue, so I'm closing the bug with this message.

If the bug I thought I'd found in where-is-internal is real, it'll come
up again in a context where fixing it is more important.

-- 
Sean Whitton